/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.6 on 2013-05-06 12:41:06,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.security.model.v2_0_4;

/**
 * A Role is a bucket for privileges, can also contain other roles.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class CRole
    implements java.io.Serializable, java.lang.Cloneable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The ID used to reference this role.
     */
    private String id;

    /**
     * A descriptive name for the role.
     */
    private String name;

    /**
     * An explanation of the use of the role.
     */
    private String description;

    /**
     * The number of minutes to wait before the session timeouts
     * because of inactivity.
     */
    private int sessionTimeout = 0;

    /**
     * Field privileges.
     */
    private java.util.List<String> privileges;

    /**
     * Field roles.
     */
    private java.util.List<String> roles;

    /**
     * Marks if this role is editable.
     */
    private boolean readOnly = false;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addPrivilege.
     * 
     * @param string
     */
    public void addPrivilege( String string )
    {
        getPrivileges().add( string );
    } //-- void addPrivilege( String )

    /**
     * Method addRole.
     * 
     * @param string
     */
    public void addRole( String string )
    {
        getRoles().add( string );
    } //-- void addRole( String )

    /**
     * Method clone.
     * 
     * @return CRole
     */
    public CRole clone()
    {
        try
        {
            CRole copy = (CRole) super.clone();

            if ( this.privileges != null )
            {
                copy.privileges = new java.util.ArrayList<String>();
                copy.privileges.addAll( this.privileges );
            }

            if ( this.roles != null )
            {
                copy.roles = new java.util.ArrayList<String>();
                copy.roles.addAll( this.roles );
            }

            return copy;
        }
        catch ( java.lang.Exception ex )
        {
            throw (java.lang.RuntimeException) new java.lang.UnsupportedOperationException( getClass().getName()
                + " does not support clone()" ).initCause( ex );
        }
    } //-- CRole clone()

    /**
     * Get an explanation of the use of the role.
     * 
     * @return String
     */
    public String getDescription()
    {
        return this.description;
    } //-- String getDescription()

    /**
     * Get the ID used to reference this role.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId()

    /**
     * Get a descriptive name for the role.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Method getPrivileges.
     * 
     * @return List
     */
    public java.util.List<String> getPrivileges()
    {
        if ( this.privileges == null )
        {
            this.privileges = new java.util.ArrayList<String>();
        }

        return this.privileges;
    } //-- java.util.List<String> getPrivileges()

    /**
     * Method getRoles.
     * 
     * @return List
     */
    public java.util.List<String> getRoles()
    {
        if ( this.roles == null )
        {
            this.roles = new java.util.ArrayList<String>();
        }

        return this.roles;
    } //-- java.util.List<String> getRoles()

    /**
     * Get the number of minutes to wait before the session
     * timeouts because of inactivity.
     * 
     * @return int
     */
    public int getSessionTimeout()
    {
        return this.sessionTimeout;
    } //-- int getSessionTimeout()

    /**
     * Get marks if this role is editable.
     * 
     * @return boolean
     */
    public boolean isReadOnly()
    {
        return this.readOnly;
    } //-- boolean isReadOnly()

    /**
     * Method removePrivilege.
     * 
     * @param string
     */
    public void removePrivilege( String string )
    {
        getPrivileges().remove( string );
    } //-- void removePrivilege( String )

    /**
     * Method removeRole.
     * 
     * @param string
     */
    public void removeRole( String string )
    {
        getRoles().remove( string );
    } //-- void removeRole( String )

    /**
     * Set an explanation of the use of the role.
     * 
     * @param description
     */
    public void setDescription( String description )
    {
        this.description = description;
    } //-- void setDescription( String )

    /**
     * Set the ID used to reference this role.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String )

    /**
     * Set a descriptive name for the role.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set list of privilege ids that will define this role.
     * 
     * @param privileges
     */
    public void setPrivileges( java.util.List<String> privileges )
    {
        this.privileges = privileges;
    } //-- void setPrivileges( java.util.List )

    /**
     * Set marks if this role is editable.
     * 
     * @param readOnly
     */
    public void setReadOnly( boolean readOnly )
    {
        this.readOnly = readOnly;
    } //-- void setReadOnly( boolean )

    /**
     * Set list of role ids, whose contents, will also define this
     * role.
     * 
     * @param roles
     */
    public void setRoles( java.util.List<String> roles )
    {
        this.roles = roles;
    } //-- void setRoles( java.util.List )

    /**
     * Set the number of minutes to wait before the session
     * timeouts because of inactivity.
     * 
     * @param sessionTimeout
     */
    public void setSessionTimeout( int sessionTimeout )
    {
        this.sessionTimeout = sessionTimeout;
    } //-- void setSessionTimeout( int )

}
